# Gallery-Archivist

---
[![Please don't upload to GitHub](https://nogithub.codeberg.page/badge.svg)](https://nogithub.codeberg.page)

My try to make a Social media archiving web tool with django and gallery-dl


## Features / Roadmap
*Note!* This is still in early development so stuff **will** change.

- - [ ] Scraping sites
- - [ ] Scheduled tasks
- - [ ] Site support
- - - [ ] [Furaffinity](https://www.furaffinity.net)
- - - [ ] [Twitter/X](https://twitter.com/)
- - [ ] Media support and previews
- - - [x] Flash (With [Ruffle](https://github.com/ruffle-rs/ruffle/))
- - - [x] PDF (With HTML embed tag)
- - - [X] Image (With HTML img tag)
- - - [ ] other text documents

---

## Usage
### Run without Docker

 * **Step 1:** Clone repo
```bash
git clone https://git.aroy-art.com/Aroy/Gallery-Archivist.git
```

* **Step 2:** Change dir to the new cloned repo
```bash
cd Gallery-Archivist
```

* **Step 3:** Make a python environment
```bash
python3 -m venv venv  
```

* **Step 4:** Activate the new python environment
```bash
source ./venv/bin/activate
```

* **Step 5:** Install python dependencies
```bash
pip install -r requirements.txt
```

* **Step 6:** Copy environment config file and change it to your liking
```bash
cp env-sample .env
```

* **Step 7:** Change directory to `./archivist`
```bash
cd ./archivist
```

* **Step 8:** Run django server
```bash
python3 manage.py runserver
```

### Manual Import Data

It is possible to import data from saved gallery-dl json files

* **Step 1:** Make sure that you are in the root folder of the project.

* **Step 2:** Make sure to activate the python environment.
```bash
source ./venv/bin/activate
```

* **Step 3:** Change directory to `./archivist`
```bash
cd ./archivist
```

* **Step 4:** Import the json data and media file from gallery-dl  
replace `<path>` with the path of the folder or json file to import

```bash
python manage.py import_data <path>
```

## Development

*Note!* Instructions are made for a modern linux environment.

 * **Step 1:** Clone repo
```bash
git clone https://git.aroy-art.com/Aroy/Gallery-Archivist.git
```

* **Step 2:** Change dir to the new cloned repo
```bash
cd Gallery-Archivist
```

* **Step 3:** Make a python environment
```bash
python3 -m venv venv  
```

* **Step 4:** Activate the new python environment
```bash
source ./venv/bin/activate
```

* **Step 5:** Install python dependencies
```bash
pip install -r requirements.txt
```

* **Step 6:** Copy environment config file and change it to your liking
```bash
cp env-sample .env
```

* **Step 7:** Run django server
```bash
python3 archivist/manage.py runserver
```